=== debian/changelog ===
qiskit-aer (0.4.1-2build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 21:48:04 +0000

qiskit-aer (0.4.1-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 26 Oct 2021 08:29:15 +0000

qiskit-aer (0.4.1-2) unstable; urgency=medium

  * Use scikit-build instead of manual cmake. (Closes: #973791)
  * d/control: add autopkgtest.
  * d/control: bump Standards-Version.
  * d/control: depend on python3-all-dev.

 -- Diego M. Rodriguez <diego@moreda.io>  Mon, 17 May 2021 16:19:44 +0200

qiskit-aer (0.4.1-1) unstable; urgency=medium

  * Initial release. (Closes: #949531)

 -- Diego M. Rodriguez <diego@moreda.io>  Thu, 11 Jun 2020 21:19:11 +0200
