=== debian/control ===
Source: qiskit-aer
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Luciano Bello <luciano@debian.org>,
           Diego M. Rodriguez <diego@moreda.io>
Build-Depends: debhelper-compat (= 13),
               cmake,
               cython3,
               dh-python,
               libmuparserx-dev,
               libopenblas-dev,
               ninja-build,
               python3-all-dev,
               python3-numpy,
               python3-pybind11,
               python3-pytest,
               python3-qiskit-terra (>= 0.12),
               python3-setuptools,
               python3-skbuild
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/qiskit-aer
Vcs-Git: https://salsa.debian.org/science-team/qiskit-aer.git
Homepage: https://qiskit.org
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python

Package: python3-qiskit-aer
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
         python3-numpy,
         python3-qiskit-terra (>= 0.12)
Description: Quantum Information Science Kit (Qiskit): Aer
 Qiskit (Quantum Information Science Kit) is a collection of software developed
 by IBM Research for working with short depth quantum circuits and building
 near term applications and experiments on quantum computers.
 .
 This package contains Aer, the element that contains high-performance quantum
 computing simulators with realistic noise models.
