=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# 653916 and http://www.cmake.org/Bug/view.php?id=12928
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export PYBUILD_NAME=qiskit-aer
export PYBUILD_TEST_PYTEST=1
export PYBUILD_SYSTEM=distutils

# Skip some tests:
# * TestNoiseTransformer: several tests depend on features that require "cvxpy"
export PYBUILD_TEST_ARGS={build_dir}/test/terra -k "not TestNoiseTransformer"

%:
	dh $@ --buildsystem=pybuild --with=python3
