=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/qiskit-aer-$1\.tar\.gz/ \
  https://github.com/Qiskit/qiskit-aer/releases .*/v?(\d\S+)\.tar\.gz
  https://github.com/Qiskit/qiskit-aer/releases?after=0.7.0 .*/v?(\d\S+)\.tar\.gz
